/*
 * 自定义全局标签
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class CustomTagSetController : BaseController
    {
        public CustomTagSetController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 自定义全局标签列表

        /// <summary>
        /// 根据条件查询自定义全局标签列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(CustomTagSet data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            string Condition = "";
            Condition += "Tags:\"" + data.Tags + "\",";
            Condition += "Title:\"" + data.Title + "\",";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询自定义全局标签列表

        /// <summary>
        /// 自定义全局标签列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(CustomTagSet data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Tags", "2"); //标签
            Fields.Add("Title", "2"); //标题

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("CustomTagSet", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }
            return Json(obj);
        }

        #endregion

        #region 增加自定义全局标签

        /// <summary>
        /// 增加或修改自定义全局标签信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加自定义全局标签

        /// <summary>
        /// 增加或修改自定义全局标签信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(CustomTagSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Tags", data.Tags); //标签
            Fields.Add("Title", data.Title); //标题
            Fields.Add("Contents", data.Contents); //内容

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("CustomTagSet", Fields, 0);
            AddSysLog(data.Id.ToString(), "CustomTagSet", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改自定义全局标签

        /// <summary>
        /// 增加或修改自定义全局标签信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            CustomTagSet editData = db.CustomTagSet.FirstOrDefault(m => m.Id == Id) ?? new CustomTagSet();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改自定义全局标签

        /// <summary>
        /// 增加或修改自定义全局标签信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(CustomTagSet data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Tags", data.Tags); //标签
            Fields.Add("Title", data.Title); //标题
            Fields.Add("Contents", data.Contents); //内容

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CustomTagSet", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "CustomTagSet", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除自定义全局标签信息

        /// <summary>
        /// 删除自定义全局标签信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CustomTagSet", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CustomTagSet", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CustomTagSet", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CustomTagSet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CustomTagSet", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CustomTagSet", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("CustomTagSet", Sort, Id);

            AddSysLog(Id.ToString(), "CustomTagSet", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.CustomTagSet.Add(new CustomTagSet()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "CustomTagSet", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(CustomTagSet data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Tags", "2"); //标签
            Fields.Add("Title", "2"); //标题

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("CustomTagSet", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "CustomTagSet", "ExportExcel");
            return Json(result);
        }

        #endregion


        #region 同步数据到redis

        public string SyncAll()
        {
            List<CustomTagSet> sets = db.CustomTagSet.ToList();
            RedisDbconn.Instance.Clear("CustomTagSet");
            RedisDbconn.Instance.AddList("CustomTagSet", sets.ToArray());
            return "success";
        }

        #endregion

    }
}
